import { world } from 'mojang-minecraft'
import { ActionFormData } from 'mojang-minecraft-ui'

const charactersGui = new ActionFormData()
charactersGui.title("Characters & Settings")
charactersGui.body("This Addon is currently in its §d§lbeta phase, §rit is highly probable that there will be occurrences of §cbugs §ror §cglitches")
charactersGui.button("The Strongest", "textures/items/gojo_moveset")
charactersGui.button("The Honored One", "textures/items/young_gojo")
charactersGui.button("The Tiger", "textures/items/yuji_moveset")
charactersGui.button("§8King of Curses(Unavailable)","textures/items/sukuna_moveset")
charactersGui.button("§cReset all techniques", "textures/items/reset_button")
charactersGui.button("§eCamera Mode", "textures/items/camera_mode_button")
charactersGui.button("§5Destructive Mode", "textures/items/terrain_destruction_button")

const cameraMode = new ActionFormData()
cameraMode.title("Enable camera mode?")
cameraMode.body("Turning it ON will adjust your camera position when using a technique")
cameraMode.button("§2Yes")
cameraMode.button("§cNo")

const destructiveMode = new ActionFormData()
destructiveMode.title("Enable destructive mode?")
destructiveMode.body("Do you like some of the techniques causing terrain destruction")
destructiveMode.button("§2Yes")
destructiveMode.button("§cNo")

world.events.beforeItemUse.subscribe(data => {
    const source = data.source
    if (data.item.id === 'ed:setting_char') charactersGui.show(source).then(result => {
        if (result.isCanceled) console.warn('GUI was canceled')
        if (result.selection === 0) source.runCommand('function gojo_moveset')
        if (result.selection === 1) source.runCommand('function younggojo_moveset')
        if (result.selection === 2) source.runCommand('function yuji_moveset')
        if (result.selection === 4) source.runCommand('function reset_techniques')
        if (result.selection === 5) cameraMode.show(source).then(result => {
            if (result.isCanceled) console.warn('GUI was canceled')
            if (result.selection === 0) source.runCommand('function camera_mode_active')
            if (result.selection === 1) source.runCommand('function camera_mode_inactive')
        })
        if (result.selection === 6) destructiveMode.show(source).then(result => {
            if (result.isCanceled) console.warn('GUI was canceled')
        if (result.selection === 0) source.runCommand('function terrain_destruction_active')
        if (result.selection === 1) source.runCommand('function terrain_destruction_inactive')
        })
    }
    )
})
